-- local cell = require"cell"
local bullet = class:extend()
bullet.new = function( self, x, y, v, d, l)
  self.p = vec(x,y)
  self.gp = (self.p/game.tile):vfloor()
  self.v = v
  self.d = d
  if l then self.l = l end
end
bullet.hit = function( self, other)
  if other then
    other:damage( 1)
  end
  game:sparks(2, self.p.x, self.p.y, 2, {255,250,0})
  self.isDead = true
end
bullet.checkColl = function( self, x, y, w, h)
  return intersects( self.p.x, self.p.y, 6, 6, x, y, w, h)
end
local angles = {r=0,d=90,l=180,u=270}

local bulletHandler = class:extend()

bulletHandler.new = function( self)
  self.stack = { }
  -- self.pool = { }
end
bulletHandler.action = function( self, x, y, dir, spd, df)
  -- local blt
  local dif = df and math.random(-df, df) or 0
  local a = math.rad( angles[ dir] + dif)
  local v = vec( math.cos( a), math.sin( a))*spd*100
  -- if #self.pool==0 then
    -- blt = bullet( pos, v, dir)
  -- else
  --   blt = table.remove( self.pool)
  --   blt.p = pos:clone( )
  --   blt.v = v
  -- end
  table.insert( self.stack, bullet( x-3, y-3, v, dir))
end
-- bulletHandler.setPosition = function( self, x, y)
--   self.gp = vec( x, y)
--   self.p = self.gp *game.tile
-- end
bulletHandler.loop = function( self, f)
  for n=1,#self.stack do
    local blt = self.stack[n]
    f( blt)
  end
end
bulletHandler.update = function( self, dt)
  for n=1,#self.stack do
    local blt = self.stack[n]
    blt.p = blt.p + blt.v*dt
    blt.gp = (blt.p/game.tile):vfloor()
  end

  for n,blt in ipairs( self.stack) do
    if blt.isDead then
      local b = table.remove( self.stack, n)
      b = nil
    end
  end
end
bulletHandler.draw = function( self)

  love.graphics.setColor(255,255,255)
  for n=1,#self.stack do
    local blt= self.stack[n]
    love.graphics.draw(game.img.misc.bullet, blt.p.x+3, blt.p.y+3, math.rad( angles[ blt.d]), 1, 1, 5, 3)
    -- love.graphics.setColor(255,255,0, 180)
    -- local p = blt.gp*game.tile
    -- love.graphics.rectangle("line", p.x, p.y, game.tile, game.tile)
  end
end
return bulletHandler
