local data = {
  img = {
    parts = {},
    misc = {
      block1 = love.graphics.newImage( 'img/block1.png' ),
      block2 = love.graphics.newImage( 'img/block2.png' ),
      block3 = love.graphics.newImage( 'img/block3.png' ),
      block4 = love.graphics.newImage( 'img/block4.png' ),
      bullet = love.graphics.newImage( 'img/bullet.png' ),
    },
    snake = {
      head = love.graphics.newImage( 'img/snek/head.png' ),
      body1 = love.graphics.newImage( 'img/snek/body1.png' ),
      body2 = love.graphics.newImage( 'img/snek/body2.png' ),
      tail = love.graphics.newImage( 'img/snek/tail.png' ),
    },
    item = {
      speedUp = love.graphics.newImage( 'img/item/spdup.png' ),
      fireRate = love.graphics.newImage( 'img/item/firerate.png' ),
      slowDown = love.graphics.newImage( 'img/item/slow.png' ),
      shrink = love.graphics.newImage( 'img/item/shrink.png' ),
      grow = love.graphics.newImage( 'img/item/grow.png' ),
      spawner = love.graphics.newImage( 'img/item/spawn.png' ),
      blocker = love.graphics.newImage( 'img/item/blocker.png' ),
      coin = love.graphics.newImage( 'img/item/coin.png' ),
      crystal = love.graphics.newImage( 'img/item/shard.png' ),
      portal = love.graphics.newImage( 'img/item/portal.png' ),
      exit = love.graphics.newImage( 'img/item/exit.png' ),
      frame = love.graphics.newImage( 'img/border.png' ),
    }
  },
  snd = {
    explosion = love.audio.newSource("snd/explosion.wav", "static"),
    shoot = love.audio.newSource("snd/shoot.wav", "static"),
    coin = love.audio.newSource("snd/coin.wav", "static"),
    portal = love.audio.newSource("snd/portal.wav", "static"),
    pickup = love.audio.newSource("snd/pickup.wav", "static"),
    showup = love.audio.newSource("snd/showup.wav", "static"),
    bite = love.audio.newSource("snd/bite.wav", "static"),
    turn = love.audio.newSource("snd/turn.wav", "static"),
    death = love.audio.newSource("snd/death.wav", "static"),
    item_dead = love.audio.newSource("snd/item_dead.wav", "static"),
  },
  colors = {
    bg = {
      {8,20,35},
      {9,21,51},
      {20,29,53},
      {0,38,45},
      {7,27,47},
      {34,20,63}
    },
    blocks = {
      {199,56,56},
      {11,161,193},
      {225,214,111},
      {87,156,92},
      {68,191,188},
      {249,136,102},
      {255,187,204}
    }
  }
}
for i=1,16 do
  table.insert( data.img.parts, love.graphics.newImage( "img/parts/parts_" .. string.format("%02d",i-1) ..".png" ))
end

return data
