local img = love.graphics.newImage("img/gameover.png")
local font = love.graphics.newImageFont("img/numbers.png", "1234567890")

local file
local filename = "scores.txt"
local button = {p = vec(180, 375), d = vec(135, 45)}
local go = {}
go.init = function( self)
  local g = anim8.newGrid(400, 200, 2000, 400)
  self.ani = anim8.newAnimation(g('1-5',1, '1-5',2), 0.2, 'pauseAtEnd')

  if not love.filesystem.exists( filename) then
    file = love.filesystem.newFile( filename)
    file:open('w') file:write( 0) file:close()
  end
end
go.enter = function( self, from)
  love.graphics.setFont(font)
  love.window.setMode( 400*screen.scale, 200*screen.scale )

  file = love.filesystem.newFile( filename)
  file:open('r')
  self.hiscore = file:read( )
  self.score = from.score or 99
  file:close()
  if from.score and tonumber(self.hiscore)< from.score then
    file:open('w') file:write( from.score) file:close()
    self.hiscore = from.score .. "\nnew!"
  end
  self.ani:gotoFrame(1)
  self.ani:resume()
  self.from = from
  self.cnv = love.graphics.newCanvas(400*screen.scale, 200*screen.scale)
  self:setCanvas()
end
go.setCanvas = function( self)
  love.graphics.setCanvas( self.cnv)
      love.graphics.setColor(255, 255, 255)
      love.graphics.printf(self.hiscore,245,140,90,"center")
      love.graphics.printf(self.score,50,140,90,"center")
    love.graphics.setCanvas()
end
go.update = function( self, dt)
  self.ani:update(dt)
end
go.draw = function( self)
  love.graphics.setColor(255, 255, 255)
  self.ani:draw( img,0,0,0,screen.scale,screen.scale)
  if self.ani:finished() then
    love.graphics.draw( self.cnv, 0, 0, 0, screen.scale,screen.scale)
  end
end
go.keypressed = function( self, k)
  if self.ani:finished() then
    return Gamestate.switch( intro)
  end
end

return go
