local snake = require"snake"

local ia = snake:extend()

ia.new = function( self, x, y, l, d)
  ia.super.new( self,x,y,l)
  -- local n = math.random(4)
  local r = ({r=0,d=90,l=180,u=270})[ d]
  local di = ({r={1,0},d={0,1},l={-1,0},u={0,-1}})[ d]

  -- self.spd = 1
  self.d = vec(di[1], di[2])
  self.newrot = math.rad(r)
  self.nwrate = 2
  self.lastDir = 'r'
  self.nwtime = 0
end
ia.update = function( self, dt)
  self.nwtime = self.nwtime + dt
  if self.nwtime>self.nwrate then
    self:setWay( )
  end
  local fgp = self.gp + self.d
  if game.map:isSolid( fgp.x, fgp.y) or self:checkTail( self.d.x, self.d.y) then
    self:setWay( )
  end

  -- timer.every( self.nwrate, self:setWay( ))
  self:move( dt)
  self.ani:update( dt)
end

--
ia.getDirection = function( self)
  local td = self.d.x == 0 and {'l','r'} or {'u','d'}
  local nd = td[math.random(2)]
  local d,r = vec(), 0

  if nd == 'l' and self.d.x == 0 then
    d.x = -1
    r =  180
  elseif nd == 'r' and self.d.x == 0 then
    d.x = 1
    r = 0
  elseif nd == 'd' and self.d.y == 0 then
    d.y = 1
    r = 90
  elseif nd == 'u' and self.d.y == 0 then
    d.y = -1
    r = 270
  else
    return false
  end
  return d,r
end

ia.setWay = function( self)
  local d,r = self:getDirection( )
  if d then
    local fgp = self.gp + d
    if game.map:isSolid( fgp.x, fgp.y) or self:checkTail( d.x, d.y) then
      d, r = self:getDirection( )
    end
    -- local nt = 0
    -- while nt<100 and (self:checkTail( d.x, d.y) or game.map:isSolid( fgp.x, fgp.y)) do
    --   d,r = self:getDirection( )
    --   fgp = self.gp + d
    --   nt = nt +1
    -- end
    self.d = vec( d.x, d.y)
    self.newrot = math.rad(r)
    self.nwrate = math.random()+(math.random()*2)
    self.nwtime = 0
  end
end

return ia
