local cell = require"cell"
local it = cell:extend()

it.new = function( self, x, y, name, life)
  it.super.new(self, x, y, 4)
  self.name = name
  self.snd = "pickup"
  self.rot = 0
  self.s = vec(1,1)
  self.cor = {255,255,255}
  local g = anim8.newGrid(16, 16, 64, 16)
  self.ani = anim8.newAnimation(g('1-4',1), 0.5)
  if life then
    self.dtimer = timer.after( life, function()
      self:die()
    end)
  end
  game.snd.showup:play()
  game:itemCounter( self.name)
end
it.action = function( self, target)

end

it.setRotation = function( self, angle)
  self.rot = math.rad( angle)
end
it.setScale = function( self, x, y)
  self.s = vec(x,y or x)
end
it.die = function( self)
  self.isDead = true
  game:itemCounter( self.name, -1)
  game:sparks( 5, self.p.x, self.p.y, 2)
  game.snd.item_dead:play()
  if self.dtimer then
    timer.cancel( self.dtimer)
  end
end
it.update = function( self, dt)
  self.ani:update( dt)
  if self.hp<=0 and not self.isDead then
    self:die()
  end
end
it.draw = function( self)
  love.graphics.setColor( self.cor)
  self.ani:draw( game.img.item[ self.name], self.p.x+8, self.p.y+8, self.rot, self.s.x, self.s.y, 8,8)
  -- love.graphics.print(self.hp, self.p.x, self.p.y-8)
end
return it
