local item = (require"item"):extend()

--[[
██████   ██████  ██████  ████████  █████  ██      ███████
██   ██ ██    ██ ██   ██    ██    ██   ██ ██      ██
██████  ██    ██ ██████     ██    ███████ ██      ███████
██      ██    ██ ██   ██    ██    ██   ██ ██           ██
██       ██████  ██   ██    ██    ██   ██ ███████ ███████
--]]

local endportal = item:extend()
endportal.new = function( self, x, y, ex, ey)
  endportal.super.new(self, x, y, 'portal', 4)
  self.endgp = vec(ex, ey)
  self.on = true
  self.cor = {230, 170, 17}
end
endportal.action = function( self, target)
  if self.on then
    if not target.warp then
      game.snd.portal:play()
      target:setPosition( self.endgp.x, self.endgp.y)
      target.warp = true
    else
      target.warp = false
    end
    self.on = false
  end
  timer.after( 1, function() self:die() end)
end
local portal = endportal:extend()
portal.new = function( self, x, y, ex, ey)
  portal.super.new(self, x, y, ex, ey)
  self.cor = {10, 146, 189}
  game:addItem("endportal", ex, ey, x, y)
end
-- ZaWarudo
local ZaWarudo = item:extend()                                                  --TODO
ZaWarudo.new = function( self, x, y)
  ZaWarudo.super.new(self, x, y, 'ZaWarudo', 3)
end
ZaWarudo.action = function( self, target)
  self:die()
end

--[[
███████ ██ ██████  ███████ ██████   █████  ████████ ███████
██      ██ ██   ██ ██      ██   ██ ██   ██    ██    ██
█████   ██ ██████  █████   ██████  ███████    ██    █████
██      ██ ██   ██ ██      ██   ██ ██   ██    ██    ██
██      ██ ██   ██ ███████ ██   ██ ██   ██    ██    ███████
--]]

local fireRate = item:extend()
fireRate.new = function( self, x, y)
  fireRate.super.new(self, x, y, 'fireRate', 5)
end
fireRate.action = function( self, target)
  game.snd[ self.snd]:play()
  target:setFirerate(0.1, 3)
  self:die()
end
--[[
███████ ██████  ███████ ███████ ██████  ██    ██ ██████
██      ██   ██ ██      ██      ██   ██ ██    ██ ██   ██
███████ ██████  █████   █████   ██   ██ ██    ██ ██████
     ██ ██      ██      ██      ██   ██ ██    ██ ██
███████ ██      ███████ ███████ ██████   ██████  ██
--]]

local speedUp = item:extend()
speedUp.new = function( self, x, y)
  speedUp.super.new(self, x, y, 'speedUp', 6)
end
speedUp.action = function( self, target)
  game.snd[ self.snd]:play()
  target:setSpeed(2, 5)
  target:coin( 10)
  self:die()
end
--[[
███████ ██       ██████  ██     ██ ██████   ██████  ██     ██ ███    ██
██      ██      ██    ██ ██     ██ ██   ██ ██    ██ ██     ██ ████   ██
███████ ██      ██    ██ ██  █  ██ ██   ██ ██    ██ ██  █  ██ ██ ██  ██
     ██ ██      ██    ██ ██ ███ ██ ██   ██ ██    ██ ██ ███ ██ ██  ██ ██
███████ ███████  ██████   ███ ███  ██████   ██████   ███ ███  ██   ████
--]]

local slowDown = item:extend()
slowDown.new = function( self, x, y)
  slowDown.super.new(self, x, y, 'slowDown', 6)
end
slowDown.action = function( self, target)
  game.snd[ self.snd]:play()
  target:setSpeed(0.5, 4)
  target:coin( 5)
  self:die()
end
--[[
███████ ██   ██ ██████  ██ ███    ██ ██   ██
██      ██   ██ ██   ██ ██ ████   ██ ██  ██
███████ ███████ ██████  ██ ██ ██  ██ █████
     ██ ██   ██ ██   ██ ██ ██  ██ ██ ██  ██
███████ ██   ██ ██   ██ ██ ██   ████ ██   ██
--]]

local shrink = item:extend()
shrink.new = function( self, x, y)
  shrink.super.new(self, x, y, 'shrink', 6)
end
shrink.action = function( self, target)
  game.snd[ self.snd]:play()
  target:grow( -2)
  target:coin( 5)
  self:die()
end
--[[
 ██████  ██████   ██████  ██     ██
██       ██   ██ ██    ██ ██     ██
██   ███ ██████  ██    ██ ██  █  ██
██    ██ ██   ██ ██    ██ ██ ███ ██
 ██████  ██   ██  ██████   ███ ███
--]]

local grow = item:extend()
grow.new = function( self, x, y)
  grow.super.new(self, x, y, 'grow', 6)
end
grow.action = function( self, target)
  game.snd[ self.snd]:play()
  target:grow( 1)
  target:coin( 10)
  self:die()
end
--[[
 ██████  ██████  ██ ███    ██
██      ██    ██ ██ ████   ██
██      ██    ██ ██ ██ ██  ██
██      ██    ██ ██ ██  ██ ██
 ██████  ██████  ██ ██   ████
--]]

local coin = item:extend()
coin.new = function( self, x, y)
  coin.super.new(self, x, y, 'coin', 6)
  self.snd = "coin"
  local v ={ 25, 50 ,100}
  self.value = v[math.random(3)]
end
coin.action = function( self, target)
  game.snd[ self.snd]:play()
  target:coin( self.value)
  self:die()
end
--[[
 ██████ ██████  ██    ██ ███████ ████████  █████  ██
██      ██   ██  ██  ██  ██         ██    ██   ██ ██
██      ██████    ████   ███████    ██    ███████ ██
██      ██   ██    ██         ██    ██    ██   ██ ██
 ██████ ██   ██    ██    ███████    ██    ██   ██ ███████
--]]
local crystal = item:extend()
crystal.new = function( self, x, y)
  crystal.super.new(self, x, y, 'crystal', 5)
  self.snd = "coin"
  self.value = 500
end
crystal.action = function( self, target)
  game.snd[ self.snd]:play()
  target:coin( self.value)
  target:crystal( 1)
  self:die()
end
--[[
███████ ██████   █████  ██     ██ ███    ██ ███████ ██████
██      ██   ██ ██   ██ ██     ██ ████   ██ ██      ██   ██
███████ ██████  ███████ ██  █  ██ ██ ██  ██ █████   ██████
     ██ ██      ██   ██ ██ ███ ██ ██  ██ ██ ██      ██   ██
███████ ██      ██   ██  ███ ███  ██   ████ ███████ ██   ██
--]]

local dirs = {
  'r','l','u','d',
  r={1,0}, l={-1,0},
  u={0,-1}, d={0,1},
}
local spawner = item:extend()
spawner.new = function( self, x, y)
  spawner.super.new(self, x, y, 'spawner')
  self.d = dirs[math.random(4)]
  self.hp = 3
  self.t = timer.every( 5, function() self:spawn( ) end)

  game.map:make_solid( x, y)
end
spawner.spawn = function( self)
  local d = dirs[self.d]
  local p = self.gp + vec(d[1], d[2])

  game:addSnek(p.x, p.y, self.d)
  self.d = dirs[math.random(4)]

  d = dirs[self.d]
  p = self.gp + vec(d[1], d[2])
  local s = game.map:isSolid(p.x, p.y)
  while s do
    self.d = dirs[math.random(4)]
    d = dirs[self.d]
    p = self.gp + vec(d[1], d[2])
    s = game.map:isSolid(p.x, p.y)
  end
end
spawner.damage = function( self, dmg)
  self.hp = self.hp -dmg
  if self.hp <= 0 then
    game.map:make_air( self.gp.x, self.gp.y)
    timer.cancel( self.t)
    self:die()
    game:addItem("crystal", self.gp.x, self.gp.y)
  end
end
--[[
██████  ██       ██████   ██████ ██   ██ ███████ ██████
██   ██ ██      ██    ██ ██      ██  ██  ██      ██   ██
██████  ██      ██    ██ ██      █████   █████   ██████
██   ██ ██      ██    ██ ██      ██  ██  ██      ██   ██
██████  ███████  ██████   ██████ ██   ██ ███████ ██   ██
--]]

local blocker = item:extend()
blocker.new = function( self, x, y, t)
  blocker.super.new(self, x, y, 'blocker')
  self.snd = "bite"
  self.d = dirs[math.random(4)]
  self.hp = 1
  self.t = timer.after( 8, function() game.map:block( self.gp.x, self.gp.y) self:die() end)
end
blocker.action = function( self, target)
  game.snd[ self.snd]:play()
  timer.cancel( self.t)
  target:setSpeed(0, 2)
  -- timer.after( 2 , function() target:setSpeed(1) end)

  self:die()
end
blocker.damage = function( self, dmg)
  self.hp = self.hp -dmg
  if self.hp <= 0 then
    timer.cancel( self.t)
    self:die()
  end
end

--[[
███    ██ ███████ ██   ██ ████████ ██      ███████ ██    ██ ███████ ██
████   ██ ██       ██ ██     ██    ██      ██      ██    ██ ██      ██
██ ██  ██ █████     ███      ██    ██      █████   ██    ██ █████   ██
██  ██ ██ ██       ██ ██     ██    ██      ██       ██  ██  ██      ██
██   ████ ███████ ██   ██    ██    ███████ ███████   ████   ███████ ███████
--]]

local frame = item:extend()
frame.new = function( self, x, y, t)
  frame.super.new(self, x, y, 'frame')
end

local nextlevel = item:extend()
nextlevel.new = function( self, x, y, t)  -- goes to a new level
  nextlevel.super.new(self, x, y, 'exit')
end
nextlevel.damage = function( self )
  --do nothing
end
nextlevel.action = function( self, target)
  target:coin( 250)
  game.next_please()
  self:die()
end


local items = {
  portal = portal,
  endportal = endportal,
  speedUp = speedUp,
  fireRate = fireRate,
  slowDown = slowDown,
  shrink = shrink,
  grow = grow,
  coin = coin,
  crystal = crystal,
  spawner = spawner,
  blocker = blocker,
  nextlevel = nextlevel,
  frame = frame,
}
items.getRndItem = function()
  local it = {'coin', 'coin', 'coin', 'speedUp', 'fireRate', 'blocker', 'slowDown', 'shrink', 'speedUp', 'grow', 'grow', 'grow'}
  return items[it[math.random(#it)]]
end
return items
