local snake = require"snake"

local play = snake:extend()
play.new = function(self, x, y)
  play.super.new( self,x,y,6)
  self.color = { 32, 144, 236}
  self.timer = nil
  self.points = 0
  self.crystal_counter = 0
  self.portal_cast = false
end
play.update = function( self, dt)
  self:move( dt)
  self.ani:update( dt)
  if love.keyboard.isDown('x') then
    self:shoot()
  end
  -- self.canShoot = false
end
play.coin = function( self, value)
  self.points = self.points+value
end
snake.crystal = function( self, value)
  self.crystal_counter = self.crystal_counter+value
end
play.keypressed = function( self, k)
  if k == 'x' then
    self.canShoot = true
  end
  if k == 'c' then
    local i, m = 0, 0
    local sp
    while i<6 do
      i = i + 1
      sp = self.gp + self.d * i
      if game.map:isSolid( sp.x, sp.y) or i >5 then
        m = i-1
        i = 6
      end
    end
    sp = self.gp + self.d*m
    local ep = game:getFreeSpot()
    game:addItem("portal", sp.x, sp.y, ep.x, ep.y)
    portal_cast = true
    timer.after( 5, function() self.portal_cast = false end)
  end
  local x,y,r
  if self.d.x == 0 then
    if k == 'left' or k == 'a' then
      x = -1
      r = 180
      self.dir = 'l'
    elseif k == 'right' or k == 'd' then
      x = 1
      r = 0
      self.dir = 'r'
    end
  end
  if self.d.y == 0 then
    if k == 'up' or k == 'w' then
      y = -1
      r = 270
      self.dir = 'u'
    elseif k == 'down' or k == 's' then
      y = 1
      r = 90
      self.dir = 'd'
    end
  end
  if (x or y) and not self:checkTail( x, y)  then
    self.d = vec( x, y)
    self.newrot = math.rad(r)
    game.snd.turn:play()
  end
end
play.keyreleased = function( self, k)
  if k == 'x' then
  --   game:shoot( self.p.x+8, self.p.y+8, self.dir)
    self.canShoot = false
    -- self.firetime = 1
    -- self.timer = nil
    -- timer.cancel(self.timerino)

  end
end
return play
