local img = love.graphics.newImage("img/warp.png")
local bgm = love.audio.newSource( "snd/start.ogg", "stream") --https://opengameart.org/content/stereotypical-90s-space-shooter-music

local warp = {}
warp.init = function( self)
  local g = anim8.newGrid( 150, 100, 300, 200)
  self.ani = anim8.newAnimation( g('1-2',1, '1-2',2 ), 0.2)
end
warp.enter = function( self, from)
  screen.setMode( 150, 100 )
  timer.after( 4, warp.goback)
  self.player = from.player
  self.player:setPosition(1,1)
  self.player.d = vec(1,0)
  self.player.dir = 'r'
  self.player.newrot = 0
  for i=1,self.player.lengh do
    self.player.tail[i]:setPosition(1,1)
  end
  bgm:play()
end
warp.goback = function( )
  Gamestate.switch( game)
end
warp.update = function( self, dt)
  self.ani:update(dt)
  timer.update( dt)
end
warp.draw = function( self)
  love.graphics.setColor(255, 255, 255)
  self.ani:draw( img)
end

return warp
